
local PetBar =  FlexBar2:NewModule("PetBar")--, "LibRockEvent-1.0");
-- If this var is incremented, SetDefaults() will be called for this module thus resetting all its settings.
PetBar.Version = 1;


-- PetBar.EventList = {
-- 	PET_BAR_UPDATE = true,
-- 	PET_BAR_UPDATE_COOLDOWN = true,
-- 	PET_UI_UPDATE = true
-- 	}

-- function PetBar:Activate()
-- 	self:AddEventListener("Blizzard", self.EventList, "PrintEvent")
-- end
-- function PetBar:Deactivate()
-- 	for k, _ in pairs(self.EventList) do
-- 		self:RemoveEventListener(k);
-- 	end
-- end

-- function PetBar:PrintEvent(...)
-- 	local t = {...}
-- 	table.foreach(t, function(i, v) t[i] = tostring(v) end)
-- 	FlexBar2:Print(table.concat(t, ", ") .. " arg1=" .. (arg1 or "nil") .. " arg2=" .. (arg2 or "nil") .. " arg3=" .. (arg3 or "nil") )
-- end



--frame:SetAttribute("type1", "pet")
--frame:SetAttribute("action1", ID)
--
-- this doesn't work because the function "TogglePetAutocast" is a secure one
-- so i don't know how to realize the TogglePetAutocast
--frame:SetAttribute("type2", "macro")
--frame:SetAttribute("macrotext2", "/script TogglePetAutocast("..ID..")")


-- test this - didn't work
-- frame:SetAttribute("type", "menu")
-- frame.menu = function() local index = this:GetAttribute("action") TogglePetAutocast(index) end


-- Sort a button table by name
function PetBar.SortButtonTable(Button1Name, Button2Name)
	local Button1Number = tonumber(string.sub(Button1Name, 13));
	local Button2Number = tonumber(string.sub(Button2Name, 13));
	if(Button1Number and Button2Number) then
		return Button1Number < Button2Number;
	else
		return Button1Name < Button2Name;
	end
end

function PetBar:BuildNewPetBar()
	-- get 10 free buttons
 	local buttons = self:GetNextFreeButtons()
	
	table.sort(buttons, PetBar.SortButtonTable);
	
	-- create them
	local button
	for i, buttonName in ipairs(buttons) do
		button = FlexBar2:Create(buttonName)
		-- make it a pet bar button if creation is successfully
		if button then
			button:SetPetButton(i)
		end
	end
	
	-- group them
	local groupList = FlexBar2.Groups
	local GroupName = "PetBar"
	-- find free suitable group name
	if groupList[GroupName] then
		local i = 1
		while true do
			GroupName = "PetBar" .. i
			if not groupList[GroupName] then
				break
			end
			i = i + 1
		end
	end
	
	FlexBar2:CreateGroup(GroupName, buttons);
	
	
	-- line them up (code copied from Button-Slashcommand /fb line .....)
	local Rows = 1;
	local Columns = tonumber(nil);
	local ButtonList = FlexBar2.Buttons;
	local StartX = ButtonList[buttons[1]].InfoTable.X;
	local StartY = ButtonList[buttons[1]].InfoTable.Y;
	local Space = 37;
	local LastScale = ButtonList[buttons[1]]:GetScale();
	local Column = 1;
	local Row = 1;
	local LastX = StartX;
	local LastY = StartY;
	for Key, ButtonName in ipairs(buttons) do
		if(Key ~= 1) then
			-- Do nothing for the first button, we position the others relative to it
			local Button = ButtonList[ButtonName];
			-- Go down a row if the current one is full
			if(Column == Columns) then
				Column = 1;
				--Row = Row + 1;
				LastY = LastY - Space * LastScale;
				LastX = StartX;
			elseif(Row == Rows) then
				Row = 1;
				LastX = LastX + Space * LastScale;
				LastY = StartY;
			else
				LastX = LastX + Space * LastScale;
				Column = Column + 1;
			end
			LastScale = Button:GetScale();
			Button:SetPosition(LastX, LastY);
			Button.InfoTable.X = LastX;
			Button.InfoTable.Y = LastY;
		end
	end
end
-- this will collect 10 buttons that are not yet existing
-- those will be named "petbarbutton#"
function PetBar:GetNextFreeButtons()
	
	local ButtonList = FlexBar2.Buttons;
	local function ButtonExists(ButtonName)
		if(ButtonList[ButtonName] == nil) then
			return false
		else
			return true
		end
	end
	
	local buttons = {}
	local i = 1
	local ButtonName = ""
	-- do it until we get 10 free buttons
	repeat 
		ButtonName = "petbarbutton" .. i
		--ButtonName = i
		
		FlexBar2:Print("GetNextFreeButtons " .. ButtonName)
		
		if ButtonExists(ButtonName) then
			-- if it exists start from scratch
			buttons = {}
		else
			-- add free button
			table.insert(buttons, ButtonName)
		end
		i = i + 1
		
	until #buttons == 10
	
	return buttons
end


-- Declare the button mixin
PetBar.ButtonMixin = {};

local ButtonUpdatePetButton = function(self, Event, NameSpace, Dispatcher, Button) if(arg1 == "pet") then self:UpdateButton(); end end;

-- didn't work
--local ToggleAutocast = function() local index = this:GetAttribute("action") TogglePetAutocast(index) end
-- This is called while loading the mixin
function PetBar.ButtonMixin:Load()
	FlexBar2:Debug("               Setting up petbar layout");
	
	local Frame = self.Frame
	
	Frame.IconAutoCastable = self.Frame:CreateTexture(nil, "OVERLAY")
	local IconAutoCastable = Frame.IconAutoCastable
 	IconAutoCastable:SetPoint("TOPLEFT", Frame, -14, 14)
 	IconAutoCastable:SetPoint("BOTTOMRIGHT", Frame, 14, -14)
	IconAutoCastable:SetTexture("Interface\\Buttons\\UI-AutoCastableOverlay")
	IconAutoCastable:Hide()
	
	Frame.AutoCast = CreateFrame("Model", nil, self.Frame);
	local AutoCast = Frame.AutoCast
	AutoCast:SetAllPoints(Frame);
	AutoCast:SetModel("Interface\\Buttons\\UI-AutoCastButton.mdx")
	AutoCast:SetScale(1.4)
	AutoCast:SetSequence(0);
	AutoCast:SetSequenceTime(0, 0);
	AutoCast:Hide()
	
	--Frame.menu = ToggleAutocast
end


function PetBar.ButtonMixin:Activate()
	FlexBar2:Debug("               Activate");
	
	self:AddEventListener("PET_BAR_UPDATE", "UpdateButton");
	--if(FlexBar2:HasModule("Action")) then
	self:AddEventListener("PET_BAR_UPDATE_COOLDOWN", "CheckCooldown");
	--end
	self:AddEventListener("UNIT_FLAGS", ButtonUpdatePetButton);
	self:AddEventListener("UNIT_AURA", ButtonUpdatePetButton);
end
function PetBar.ButtonMixin:Deactivate()
	FlexBar2:Debug("               Deactivate");
	self:RemoveEventListener("PET_BAR_UPDATE", "UpdateButton");
	--if(FlexBar2:HasModule("Action")) then
		self:RemoveEventListener("PET_BAR_UPDATE_COOLDOWN", "CheckCooldown");
	--end
	
	self:RemoveEventListener("UNIT_FLAGS", ButtonUpdatePetButton);
	self:RemoveEventListener("UNIT_AURA", ButtonUpdatePetButton);
	
	
	self:UpdatePetButtonTexture("")
	if(FlexBar2:HasModule("Highlighting")) then
		self:SetOuterHighlight("Equipped", false)
	end
	self.Frame.IconAutoCastable:Hide()
	self.Frame.AutoCast:Hide()
end

function PetBar.ButtonMixin:SetPetButton(PetButtonId)
	FlexBar2:Debug("               SetPetButton id=" .. (PetButtonId or "nil"))
	if type(PetButtonId) == "string" then
		PetButtonId = tonumber(PetButtonId)
	end
	
	--self:SetAttribute("type1", "pet")
	self:SetModifiedAttribute("type", "pet")
	--self:SetAttribute("type", "pet")
	
	--self:SetAttribute("action1", PetButtonId)
	self:SetModifiedAttribute("action", PetButtonId)
	--self:SetAttribute("action", PetButtonId)
	
	if(FlexBar2:HasModule("Action")) then
		self:LockAction()
	end
	
	self:UpdateButton()
end

--local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
function PetBar.ButtonMixin:UpdatePetButtonTexture(Icon)
	if Icon == nil then
		local _, _, Icon, _, _, _, _ = self:GetPetButtonData()
	end
	FlexBar2:Debug("Updating Icon to: " , Icon);
	self:SetIcon(Icon)
end

function PetBar.ButtonMixin:UpdateButton()
	--FlexBar2:Print("               UpdatePetButton");
	local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = self:GetPetButtonData()
	if not name then 
		self:UpdatePetButtonTexture("")
		if(FlexBar2:HasModule("Highlighting")) then
			self:SetOuterHighlight("Equipped", false)
		end
		self.Frame.IconAutoCastable:Hide()
		self.Frame.AutoCast:Hide()
		
		
	else
		-- Update Icon
		self:UpdatePetButtonTexture(texture)
		
		-- Update Highlight
		if(FlexBar2:HasModule("Highlighting")) then
			if isActive then
				self:SetOuterHighlight("Equipped", true)
			else
				self:SetOuterHighlight("Equipped", false)
			end
		end
		
		-- Update AutoCastable
		if autoCastAllowed then
			self.Frame.IconAutoCastable:Show()
			if autoCastEnabled then
				self.Frame.AutoCast:Show()
			else
				self.Frame.AutoCast:Hide()
			end
		else
			self.Frame.IconAutoCastable:Hide()
			self.Frame.AutoCast:Hide()
		end
	end
end

function PetBar.ButtonMixin:GetPetButtonIndex()
	--local ActionType = self:GetAttribute("type");
	local ActionType = self:GetModifiedAttribute("type");
	FlexBar2:Debug(ActionType);
	-- If its a pet action, get the pets action texture using its id
	if(ActionType == "pet") then
		--local petBtnId = self:GetAttribute("action")
		local petBtnId = self:GetModifiedAttribute("action")
		
		if petBtnId and petBtnId ~= "" then
			return petBtnId
		end
	end
	return nil
end
function PetBar.ButtonMixin:GetPetButtonData(index)
	local index = index or self:GetPetButtonIndex()
	if index then
		local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(index);
		if isToken then
			name = getglobal(name)
			texture = getglobal(texture)
		end
		return name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled
	else
		return nil
	end
end

